"""Initialize database.

Revision ID: ad9440a15954
Revises:
Create Date: 2020-08-31 16:37:35.942337+00:00

"""
import sqlalchemy as sa
import sqlalchemy_utils.types
from alembic import op

# revision identifiers, used by Alembic.
revision = "ad9440a15954"
down_revision = None
branch_labels = None
depends_on = None


def upgrade() -> None:
    """Upgrade database."""
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "deid_log",
        sa.Column("id", sqlalchemy_utils.types.uuid.UUIDType(), nullable=False),
        sa.Column("created", sa.DateTime(), nullable=True),
        sa.Column("timestamp", sa.DateTime(), nullable=True),
        sa.Column("AccessionNumber", sa.String(length=16), nullable=True),
        sa.Column("PatientBirthDate", sa.String(length=8), nullable=True),
        sa.Column("PatientID", sa.String(length=64), nullable=True),
        sa.Column("PatientName", sa.String(length=512), nullable=True),
        sa.Column("StudyInstanceUID", sa.String(length=64), nullable=True),
        sa.Column("StudyID", sa.String(length=16), nullable=True),
        sa.Column("StudyDate", sa.String(length=8), nullable=True),
        sa.Column("StudyTime", sa.String(length=16), nullable=True),
        sa.Column("StudyDateTime", sa.String(length=26), nullable=True),
        sa.Column("StudyDescription", sa.String(length=64), nullable=True),
        sa.Column("SeriesInstanceUID", sa.String(length=64), nullable=True),
        sa.Column("SeriesDate", sa.String(length=8), nullable=True),
        sa.Column("SeriesTime", sa.String(length=16), nullable=True),
        sa.Column("SeriesDateTime", sa.String(length=26), nullable=True),
        sa.Column("SeriesDescription", sa.String(length=64), nullable=True),
        sa.Column("TimezoneOffsetFromUTC", sa.String(length=16), nullable=True),
        sa.Column("DeidentifiedTags", sa.JSON(), nullable=False),
        sa.PrimaryKeyConstraint("id"),
    )
    with op.batch_alter_table("deid_log", schema=None) as batch_op:
        batch_op.create_index(
            batch_op.f("ix_deid_log_AccessionNumber"), ["AccessionNumber"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_PatientBirthDate"),
            ["PatientBirthDate"],
            unique=False,
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_PatientID"), ["PatientID"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_PatientName"), ["PatientName"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_SeriesDate"), ["SeriesDate"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_SeriesDateTime"), ["SeriesDateTime"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_SeriesDescription"),
            ["SeriesDescription"],
            unique=False,
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_SeriesInstanceUID"),
            ["SeriesInstanceUID"],
            unique=False,
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_SeriesTime"), ["SeriesTime"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_StudyDate"), ["StudyDate"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_StudyDateTime"), ["StudyDateTime"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_StudyDescription"),
            ["StudyDescription"],
            unique=False,
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_StudyID"), ["StudyID"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_StudyInstanceUID"),
            ["StudyInstanceUID"],
            unique=False,
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_StudyTime"), ["StudyTime"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_TimezoneOffsetFromUTC"),
            ["TimezoneOffsetFromUTC"],
            unique=False,
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_created"), ["created"], unique=False
        )
        batch_op.create_index(
            batch_op.f("ix_deid_log_timestamp"), ["timestamp"], unique=False
        )

    # ### end Alembic commands ###


def downgrade() -> None:
    """Downgrade database."""
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table("deid_log", schema=None) as batch_op:
        batch_op.drop_index(batch_op.f("ix_deid_log_timestamp"))
        batch_op.drop_index(batch_op.f("ix_deid_log_created"))
        batch_op.drop_index(batch_op.f("ix_deid_log_TimezoneOffsetFromUTC"))
        batch_op.drop_index(batch_op.f("ix_deid_log_StudyTime"))
        batch_op.drop_index(batch_op.f("ix_deid_log_StudyInstanceUID"))
        batch_op.drop_index(batch_op.f("ix_deid_log_StudyID"))
        batch_op.drop_index(batch_op.f("ix_deid_log_StudyDescription"))
        batch_op.drop_index(batch_op.f("ix_deid_log_StudyDateTime"))
        batch_op.drop_index(batch_op.f("ix_deid_log_StudyDate"))
        batch_op.drop_index(batch_op.f("ix_deid_log_SeriesTime"))
        batch_op.drop_index(batch_op.f("ix_deid_log_SeriesInstanceUID"))
        batch_op.drop_index(batch_op.f("ix_deid_log_SeriesDescription"))
        batch_op.drop_index(batch_op.f("ix_deid_log_SeriesDateTime"))
        batch_op.drop_index(batch_op.f("ix_deid_log_SeriesDate"))
        batch_op.drop_index(batch_op.f("ix_deid_log_PatientName"))
        batch_op.drop_index(batch_op.f("ix_deid_log_PatientID"))
        batch_op.drop_index(batch_op.f("ix_deid_log_PatientBirthDate"))
        batch_op.drop_index(batch_op.f("ix_deid_log_AccessionNumber"))

    op.drop_table("deid_log")
    # ### end Alembic commands ###
